VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsTrickModulator"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' clsTrickModulator  -  
'     (The trick), 2014

Option Explicit

Private mBands      As Long     '  
Private mDryWet     As Single   '     
Private mVolume     As Single   ' 
Private mLevels()   As Single   ' 

' // 
Public Property Let Volume(ByVal Value As Single)
    mVolume = Value
End Property
Public Property Get Volume() As Single
    Volume = mVolume
End Property

' // 
Public Function SetLevels(Value() As Single) As Boolean
    mLevels = Value
End Function
Public Property Get Levels(ByVal index As Long) As Single
    Levels = mLevels(index)
End Property

' // 
Public Property Let DryWet(ByVal Value As Single)
    If Abs(Value) > 1 Then
        err.Raise 9
        Exit Property
    End If
    mDryWet = Value
End Property
Public Property Get DryWet() As Single
    DryWet = mDryWet
End Property

' //  
Public Property Let Bands(ByVal Value As Long)
    If Value > 128 Or Value <= 0 Then
        err.Raise 9
        Exit Property
    End If
    mBands = Value
End Property
Public Property Get Bands() As Long
    Bands = mBands
End Property

' //   
Public Function Process(carrier() As Single, modulation() As Single) As Boolean
    Dim nCount          As Long
    Dim band            As Long
    Dim endBand         As Long
    Dim sample          As Long
    Dim samplePerBand   As Long
    Dim offsetSample    As Long
    Dim modValue        As Single
    Dim ampValue        As Single
    Dim invDryWet       As Single
    Dim FFTSize         As Long
    
    invDryWet = 1 - mDryWet
    FFTSize = (UBound(carrier, 2) + 1)
    '    
    nCount = FFTSize \ 2
    '     
    samplePerBand = nCount \ mBands
    '   
    ampValue = (Sqr(mBands) * invDryWet) / 2.5 + mDryWet
    '   
    For band = 0 To mBands - 1
        '    
        endBand = band * samplePerBand + samplePerBand
        If endBand >= nCount Then endBand = nCount - 1
        '       
        modValue = 0
        '      
        For sample = band * samplePerBand To endBand
            '       
            modValue = modValue + Sqr(modulation(0, sample) * modulation(0, sample) + _
                                      modulation(1, sample) * modulation(1, sample))
        Next
        '    
        For sample = band * samplePerBand To endBand
            carrier(0, sample) = ((carrier(0, sample) * modValue * invDryWet) + _
                                 (modulation(0, sample) * mDryWet)) * ampValue * mLevels(sample) * mVolume
            carrier(1, sample) = ((carrier(1, sample) * modValue * invDryWet) + _
                                 (modulation(1, sample) * mDryWet)) * ampValue * mLevels(sample) * mVolume
        Next
    Next
    
End Function

Private Sub Class_Initialize()
    mDryWet = 0
    mVolume = 1
End Sub
