VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsTrickOverlappedBuffer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' clsTrickOverlappedBuffer  -   
'     (The trick), 2014

Option Explicit

Private iBuffer()   As Single       '   
Private oBuffer()   As Single       '   
Private mInit       As Boolean      '   
Private miWritePtr  As Long         '       
Private moWritePtr  As Long         '       
Private mWndSize    As Long         '     /
Private mOverlap    As Long         '    
Private iPtr        As Long         '      
Private oPtr        As Long         '      
Private sampleSize  As Long         '    

' // 
Public Function Init(ByVal windowSize As Long, ByVal overlapSizeSamples As Long) As Boolean

    If overlapSizeSamples > windowSize Or overlapSizeSamples <= 0 Then Exit Function
    If windowSize <= 0 Then Exit Function
    
    '    2       windowSize
    ReDim iBuffer(1, windowSize * 2 - 1)
    ReDim oBuffer(1, windowSize * 2 - 1)
    
    mInit = True
    mWndSize = windowSize
    mOverlap = overlapSizeSamples
    miWritePtr = mWndSize
    
    Init = True

End Function

' //     
Public Function WriteInputData(data() As Single) As Boolean

    memcpy iBuffer(0, miWritePtr), data(0, 0), (UBound(data, 2) + 1) * sampleSize
    miWritePtr = IIf(miWritePtr, 0, mWndSize)
    WriteInputData = True
    
End Function

' //     
Public Function WriteOutputData(data() As Single) As Boolean
    Dim sampleCount As Long
    Dim inSample    As Long
    Dim pointer     As Long
    Dim rest        As Long
    
    pointer = moWritePtr
    '    
    '      
    sampleCount = mWndSize * 2 - pointer
    '      ,    
    If sampleCount > mOverlap Then sampleCount = mOverlap
    ' 
    For inSample = 0 To sampleCount - 1
    
        oBuffer(0, pointer) = oBuffer(0, pointer) + data(0, inSample)
        pointer = pointer + 1
        
    Next
    '    ,   
    If sampleCount < mOverlap Then
    
        pointer = 0
        
        Do While pointer < mOverlap - sampleCount
        
            oBuffer(0, pointer) = oBuffer(0, pointer) + data(0, inSample)
            pointer = pointer + 1
            inSample = inSample + 1
            
        Loop
        
    End If
    
    moWritePtr = pointer
    
    '    
    sampleCount = mWndSize * 2 - pointer
    rest = mWndSize - mOverlap
    '      
    If sampleCount > rest Then sampleCount = rest
    ' 
    If sampleCount Then memcpy oBuffer(0, pointer), data(0, inSample), sampleCount * sampleSize
    '   ,    
    If sampleCount < rest Then
    
        pointer = 0
        memcpy oBuffer(0, pointer), data(0, inSample), (rest - sampleCount) * sampleSize
        
    End If
    
    WriteOutputData = True
    
End Function

' //    
Public Function GetInputBuffer(data() As Single) As Boolean
    Dim sampleCount As Long
    '       
    sampleCount = mWndSize * 2 - iPtr
    ' 
    If sampleCount > mWndSize Then sampleCount = mWndSize
    ' 
    If sampleCount > 0 Then
        memcpy data(0, 0), iBuffer(0, iPtr), sampleCount * sampleSize
    End If
    '      
    If sampleCount < mWndSize Then
        memcpy data(0, sampleCount), iBuffer(0, 0), (mWndSize - sampleCount) * sampleSize
    End If
    '  
    iPtr = (iPtr + mOverlap) Mod mWndSize * 2

    GetInputBuffer = True

End Function

' //    
Public Function GetOutputBuffer(data() As Single) As Boolean
    Dim sampleCount As Long
    '       
    sampleCount = mWndSize * 2 - oPtr
    ' 
    If sampleCount > mWndSize Then sampleCount = mWndSize
    ' 
    If sampleCount > 0 Then
        memcpy data(0, 0), oBuffer(0, oPtr), sampleCount * sampleSize
        oPtr = oPtr + sampleCount
    End If
    '      
    If sampleCount < mWndSize Then
        memcpy data(0, sampleCount), oBuffer(0, 0), (mWndSize - sampleCount) * sampleSize
        oPtr = mWndSize - sampleCount
    End If

    GetOutputBuffer = True

End Function

Private Sub Class_Initialize()
    sampleSize = 8
End Sub
