VERSION 5.00
Begin VB.UserControl ctlTrickCommand 
   BackColor       =   &H00000000&
   ClientHeight    =   3600
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   ForeColor       =   &H00FFFFFF&
   ScaleHeight     =   240
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   320
End
Attribute VB_Name = "ctlTrickCommand"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' ctlTrickCommand.ctl  -   
'     (The trick), 2014

Option Explicit

'  
Public Event Click()

Private mIcon As StdPicture             ' 

Dim mSelected   As Boolean              '  
Dim mRedrawBack As Boolean              '   
Dim hBufferBmp  As Long                 '  
Dim hBackBmp    As Long                 '  
Dim tmpDC       As Long                 '   
Dim bufDC       As Long                 '   

' // 
Public Property Set Icon(v As StdPicture)
    
    Set mIcon = v
    Redraw
    PropertyChanged "Icon"
        
End Property
Public Property Get Icon() As StdPicture

    Set Icon = mIcon

End Property

' // 
Public Sub Redraw()
    '   
    SaveDC tmpDC
    '   
    If mRedrawBack Then

        Dim rc      As RECT
        '          
        If CBool(hBufferBmp) Or CBool(hBackBmp) Then
        
            RestoreDC bufDC, -1
            DeleteObject hBufferBmp
            DeleteObject hBackBmp
            
        End If
        '     
        hBufferBmp = CreateCompatibleBitmap(UserControl.hdc, UserControl.ScaleWidth, UserControl.ScaleHeight)
        hBackBmp = CreateCompatibleBitmap(UserControl.hdc, UserControl.ScaleWidth, UserControl.ScaleHeight)
        '  
        SaveDC bufDC
        SelectObject bufDC, hBufferBmp
        '     
        SelectObject tmpDC, hBackBmp
        GetClientRect UserControl.hwnd, rc
        MapWindowPoints UserControl.hwnd, UserControl.ContainerHwnd, rc, 2
        SetViewportOrgEx tmpDC, -rc.Left, -rc.Top, ByVal 0&
        SendMessageA UserControl.ContainerHwnd, WM_PAINT, tmpDC, ByVal 0&
        SetViewportOrgEx tmpDC, 0, 0, ByVal 0&
        mRedrawBack = False
        
    End If
    '  
    SelectObject tmpDC, hBackBmp
    BitBlt bufDC, 0, 0, UserControl.ScaleWidth, UserControl.ScaleHeight, _
           tmpDC, 0, 0, vbSrcCopy
    
    If Not mIcon Is Nothing Then
        '  
        Dim wdh As Long
        Dim hgh As Long
        
        wdh = ScaleX(mIcon.width, vbHimetric, vbPixels)
        hgh = ScaleY(mIcon.height, vbHimetric, vbPixels) \ 2
        
        SelectObject tmpDC, mIcon.Handle
        
        If mSelected Then
            AlphaBlend bufDC, 0, 0, wdh, hgh, tmpDC, 0, hgh, wdh, hgh, AB_32Bpp255
        Else
            AlphaBlend bufDC, 0, 0, wdh, hgh, tmpDC, 0, 0, wdh, hgh, AB_32Bpp255
        End If
        
    End If
    
    '     
    BitBlt UserControl.hdc, 0, 0, UserControl.ScaleWidth, UserControl.ScaleHeight, _
           bufDC, 0, 0, vbSrcCopy
    '  
    RestoreDC tmpDC, -1
    
End Sub

' //  
Private Sub UserControl_Initialize()
    ' 
    bufDC = CreateCompatibleDC(UserControl.hdc)
    tmpDC = CreateCompatibleDC(UserControl.hdc)

End Sub

' //  
Private Sub UserControl_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)

    mSelected = True
    Redraw
    
End Sub

' //  
Private Sub UserControl_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
        
    If x >= 0 And y >= 0 And _
       x <= UserControl.ScaleWidth And y <= UserControl.ScaleHeight _
       And mSelected Then
        
        mSelected = False
        Redraw
        RaiseEvent Click
        
    ElseIf mSelected Then
    
        mSelected = False
        Redraw
        
    End If
    
End Sub

' // 
Private Sub UserControl_Paint()
    
    If mRedrawBack Then
        Redraw
    End If
    
    BitBlt UserControl.hdc, 0, 0, UserControl.ScaleWidth, UserControl.ScaleHeight, _
           bufDC, 0, 0, vbSrcCopy
           
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)

    Set mIcon = PropBag.ReadProperty("Icon", Nothing)

End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)

    PropBag.WriteProperty "Icon", mIcon, Nothing
    
End Sub

' //  
Private Sub UserControl_Resize()
    
    mRedrawBack = True
    
End Sub

' //  
Private Sub UserControl_Terminate()
    If CBool(hBufferBmp) Or CBool(hBackBmp) Then
    
        RestoreDC bufDC, -1
        DeleteObject hBufferBmp
        DeleteObject hBackBmp
        
    End If
    
    DeleteDC tmpDC
    DeleteDC bufDC
End Sub



