VERSION 5.00
Begin VB.UserControl ctlTrickEqualizer 
   BackColor       =   &H00000000&
   ClientHeight    =   3600
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   BeginProperty Font 
      Name            =   "Arial"
      Size            =   6
      Charset         =   204
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H00FFFFFF&
   ScaleHeight     =   240
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   320
End
Attribute VB_Name = "ctlTrickEqualizer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' ctlTrickEqualizer.ctl  -    
'     (The trick), 2014

Option Explicit

'   
Public Event Change()

'   
Private Type Point
    px  As Single
    py  As Single
End Type

'   
Private Const MarkerSize    As Long = 8

Private Points()    As Point            '   
Private countPoints As Long             '   

Dim gdipToken   As Long                 '  GDI+
Dim mBufGraph   As Long                 ' Graphics 
Dim mPenThin    As Long                 '  
Dim mPenThick   As Long                 '  
Dim mSelected   As Long                 '   
Dim mRedrawBack As Boolean              '   
Dim hBufferBmp  As Long                 '  
Dim hBackBmp    As Long                 '  
Dim tmpDC       As Long                 '   
Dim bufDC       As Long                 '   

' //  ,       
Public Sub GetCurve(data() As Single)
    Dim index   As Long
    Dim posX    As Single
    Dim iPts    As Long
    Dim delta   As Single
    Dim t       As Single
    
    iPts = 1
    data(0) = GetValue(Points(0).py)
    
    '    
    For index = 1 To UBound(data)
        
        delta = index / UBound(data)
        '      
        posX = (Log(delta) / Log(10) + 3) / 3
        '   
        Do While posX >= Points(iPts).px
        
            iPts = iPts + 1
            If iPts = countPoints Then
            
                data(index) = GetValue(Points(iPts - 1).py)
                Exit For
                
            End If
            
        Loop
        
        If posX < 0 Then posX = 0
        '   
        t = (posX - Points(iPts - 1).px) / (Points(iPts).px - Points(iPts - 1).px)
        data(index) = GetValue(Interpolation(Points(iPts - 1).py, Points(iPts).py, t))

    Next
    
End Sub

' // 
Public Sub Redraw()
    Dim index   As Long
    Dim pts()   As POINTF
    Dim Value   As Single
    Dim posY    As Long
    Dim posX    As Long
    Dim multi   As Single
    Dim grid    As Long
    
    '   
    SaveDC tmpDC
    '   
    If mRedrawBack Then

        Dim vtx()   As TRIVERTEX
        Dim grRect  As GRADIENT_RECT
        Dim tmpFont As IFont
        '    
        Set tmpFont = UserControl.Font
        '          
        If CBool(hBufferBmp) Or CBool(hBackBmp) Then
        
            RestoreDC bufDC, -1
            GdipDeleteGraphics mBufGraph
            DeleteObject hBackBmp
            DeleteObject hBufferBmp
            
        End If
        '     
        hBufferBmp = CreateCompatibleBitmap(UserControl.hdc, UserControl.ScaleWidth, UserControl.ScaleHeight)
        hBackBmp = CreateCompatibleBitmap(UserControl.hdc, UserControl.ScaleWidth, UserControl.ScaleHeight)
        '  
        SaveDC bufDC
        SelectObject bufDC, hBufferBmp
        SelectObject bufDC, GetStockObject(DC_PEN)
        SelectObject bufDC, tmpFont.hFont
        SetBkMode bufDC, TRANSPARENT
        '   graphics
        GdipCreateFromHDC bufDC, mBufGraph
        '  
        SelectObject tmpDC, hBackBmp
        '  
        GdipSetSmoothingMode mBufGraph, SmoothingModeAntiAlias
        '  
        ReDim vtx(1)
        '  
        vtx(0) = GdiTrivertex(0, 0, Colors.col_GradA1)
        vtx(1) = GdiTrivertex(UserControl.ScaleWidth, UserControl.ScaleHeight, Colors.col_GradA2)
        '   
        grRect = GdiGradientRect(0, 1)
        ' 
        GradientFill tmpDC, vtx(0), 2, grRect, 1, GRADIENT_FILL_RECT_V
        '  
        SelectObject tmpDC, GetStockObject(DC_PEN)
        SelectObject tmpDC, tmpFont.hFont
        SetDCPenColor tmpDC, toVBColor(Colors.col_Grid)
        SetTextColor tmpDC, toVBColor(Colors.col_TextInactive)
        SetBkMode tmpDC, TRANSPARENT
        
        Dim label   As String
        '  -
        multi = 0.01
        
        For grid = 0 To 3
            '  
            Value = -(Log(multi) / Log(10))
            posY = Value * UserControl.ScaleHeight / 3 + UserControl.ScaleHeight / 2
            '  
            SetDCPenColor tmpDC, toVBColor(col_Grid)
            MoveToEx tmpDC, 0, posY, ByVal 0&
            LineTo tmpDC, UserControl.ScaleWidth, posY
            '   
            label = -Int(20 * Value) & " db"
            TextOut tmpDC, 2, posY + 2, StrPtr(label), Len(label)
            '  
            SetDCPenColor tmpDC, toVBColor(col_GridInactive)
            posY = posY + UserControl.ScaleHeight / 10
            MoveToEx tmpDC, 0, posY, ByVal 0&
            LineTo tmpDC, UserControl.ScaleWidth, posY
                        
            multi = multi * 10
            
        Next
        '  -
        multi = 0.001
        Value = SampleRate / 2

        For grid = 0 To 3
            '  
            posX = (Log(multi) / Log(10) + 3) * UserControl.ScaleWidth / 3
            '  
            SetDCPenColor tmpDC, toVBColor(col_Grid)
            MoveToEx tmpDC, posX, 0, ByVal 0&
            LineTo tmpDC, posX, UserControl.ScaleHeight
            '   
            label = multi * Value & " Hz"
            
            TextOut tmpDC, posX + 2, 0, StrPtr(label), Len(label)
            '  
            posX = posX + UserControl.ScaleWidth / 6
            SetDCPenColor tmpDC, toVBColor(col_GridInactive)
            MoveToEx tmpDC, posX, 0, ByVal 0&
            LineTo tmpDC, posX, UserControl.ScaleHeight
                        
            multi = multi * 10

        Next
        
        mRedrawBack = False
        
    End If
    '   
    SelectObject tmpDC, hBackBmp
    '    
    BitBlt bufDC, 0, 0, UserControl.ScaleWidth, UserControl.ScaleHeight, _
           tmpDC, 0, 0, vbSrcCopy

    Dim seg         As Long
    Dim numSegs     As Long
    Dim nextPoint   As Long
    Dim prevPoint   As Long
    Dim pIndex      As Long
    Dim isNext      As Boolean
    '  
    numSegs = UserControl.ScaleWidth / 4
    ReDim Preserve pts(numSegs * 2 - 1)
    
    nextPoint = UserControl.ScaleWidth * Points(1).px
    pIndex = 1
    seg = 0
    posX = 0
    '       ,   
    Do
        '    
        If isNext Then
        
            pIndex = pIndex + 1
            
            If pIndex >= countPoints Then Exit Do
        
            prevPoint = nextPoint
            nextPoint = UserControl.ScaleWidth * Points(pIndex).px
            isNext = False
            
        End If
        
        If posX > nextPoint Then
            
            posX = nextPoint
            isNext = True
            
        End If
        
        If nextPoint <> prevPoint Then
        
            Value = (posX - prevPoint) / (nextPoint - prevPoint)
            pts(seg).x = posX
            pts(seg).y = Interpolation(Points(pIndex - 1).py, Points(pIndex).py, Value) * UserControl.ScaleHeight
                
            seg = seg + 1
            posX = posX + 4
            
        Else
        
            isNext = True
            
        End If
            
    Loop
    '   ()
    GdipSetPenColor mPenThick, Colors.col_Curve
    GdipDrawLines mBufGraph, mPenThick, pts(0), seg
    
    SelectObject bufDC, GetStockObject(DC_BRUSH)
    SetTextColor bufDC, toVBColor(col_Text)
    SetDCBrushColor bufDC, Colors.col_BackColor
    
    Dim rc  As RECT
    Dim sz  As Size
    '  
    For index = 0 To countPoints - 1
        
        posX = Points(index).px * UserControl.ScaleWidth
        posY = Points(index).py * UserControl.ScaleHeight
        
        If index = mSelected Then
            '   
            GdipSetPenColor mPenThin, Colors.col_MarkerSelection
            GdipDrawEllipseI mBufGraph, mPenThin, posX - MarkerSize \ 2, _
                         posY - MarkerSize \ 2, MarkerSize, MarkerSize
            '      ,    
            label = FormatValue(GetValue(Points(index).py)) & vbNewLine & _
                    Int(GetFrequency(Points(index).px) * SampleRate / 2) & " Hz"
                    
            SetRect rc, posX, posY, UserControl.ScaleWidth, UserControl.ScaleHeight
            '   
            DrawText bufDC, StrPtr(label), Len(label), rc, DT_CALCRECT
            
            sz.cx = rc.Right - rc.Left
            sz.cy = rc.Bottom - rc.Top
            '        
            If rc.Right > UserControl.ScaleWidth Then sz.cx = -sz.cx Else sz.cx = 0
            If rc.Top > sz.cy Then sz.cy = -sz.cy
            
            OffsetRect rc, sz.cx, sz.cy
            ' 
            Rectangle bufDC, rc.Left - 1, rc.Top - 1, rc.Right + 1, rc.Bottom + 1
            ' 
            DrawText bufDC, StrPtr(label), Len(label), rc, 0
        
        Else
            
            GdipSetPenColor mPenThin, Colors.col_Marker
            GdipDrawEllipseI mBufGraph, mPenThin, posX - MarkerSize \ 2, _
                         posY - MarkerSize \ 2, MarkerSize, MarkerSize
                         
        End If

    Next
    
    SelectObject bufDC, GetStockObject(NULL_BRUSH)
    SetDCPenColor bufDC, toVBColor(col_FrameColor)
    '  
    Rectangle bufDC, 0, 0, UserControl.ScaleWidth, UserControl.ScaleHeight
    '     
    BitBlt UserControl.hdc, 0, 0, UserControl.ScaleWidth, UserControl.ScaleHeight, _
           bufDC, 0, 0, vbSrcCopy
    '  
    RestoreDC tmpDC, -1

End Sub

' //     
Private Function FormatValue(ByVal Value As Single) As String
    Select Case Value
    Case Is > 0.1
        FormatValue = Format(Value, "#0%")
    Case Is > 0.01
        FormatValue = Format(Value, "#0.0%")
    Case Else
        FormatValue = Format(Value, "0.000%")
    End Select
End Function

' //      
Private Function GetValue(ByVal y As Single) As Single

    GetValue = 10 ^ (((1 - y) - 0.5) * 3)
    
End Function

' //       
Private Function GetFrequency(ByVal x As Single) As Single

    GetFrequency = 10 ^ (x * 3 - 3)
    
End Function

' //  
Private Function AddPoint(ByVal x As Single, ByVal y As Single) As Long
    Dim iPts    As Long
    Dim posX    As Single
    Dim iInrt   As Long
    
    posX = x / UserControl.ScaleWidth
    '       
    For iPts = 0 To countPoints - 1
    
        If Points(iPts).px > posX Then
        
            iInrt = iPts
            Exit For
            
        End If
        
    Next
     
    ReDim Preserve Points(countPoints)
    '     
    For iPts = countPoints To iInrt + 1 Step -1
        
        Points(iPts) = Points(iPts - 1)
        
    Next
    '   
    Points(iInrt).px = posX
    Points(iInrt).py = y / UserControl.ScaleHeight
    
    countPoints = countPoints + 1
    AddPoint = iInrt
    
    RaiseEvent Change
    
End Function

' //  
Private Sub RemovePoint(ByVal index As Long)
    Dim iSwap   As Long
    '    
    If Not (index = 0 Or index = countPoints - 1) Then
        '   
        For iSwap = index To countPoints - 2
            
            Points(iSwap) = Points(iSwap + 1)
        
        Next
        
        countPoints = countPoints - 1
        
        RaiseEvent Change
        
    End If
    
End Sub

' //  
Private Sub MovePoint(ByVal index As Long, ByVal x As Single, ByVal y As Single)
    Dim colPoint    As Long
    Dim iSwap       As Long
    Dim direction   As Long
    '    
    If y < 0 Then y = 0 Else If y > 1 Then y = 1
    If x < 0 Then x = 0 Else If x > 1 Then x = 1
    '      
    If Not (index = 0 Or index = countPoints - 1) Then
        '   
        If Points(index).px > x Then
            direction = -1
        Else
            direction = 1
        End If
        '  
        colPoint = index + direction
        '   ,   
        Do While (Points(colPoint).px - x) * direction < 0
            colPoint = colPoint + direction
        Loop
        
        colPoint = colPoint - direction * 2
        '   
        For iSwap = index To colPoint Step direction
            
            Points(iSwap) = Points(iSwap + direction)
            
        Next
        '  
        mSelected = colPoint + direction
        Points(mSelected).px = x
        
    End If
    
    Points(index).py = y
    
    RaiseEvent Change
    
End Sub

' //  
Private Sub UserControl_Initialize()
    Dim ret     As Long
    Dim gpInput As GdiplusStartupInput
    '  GDI+
    gpInput.GdiplusVersion = 1
    ret = GdiplusStartup(gdipToken, gpInput)
    
    If ret Then
        MsgBox "Gdi+ startup error"
        Exit Sub
    End If
    ' 
    GdipCreatePen1 Colors.col_FrameColor, 1, UnitPixel, mPenThin
    GdipCreatePen1 Colors.col_Curve, 2, UnitPixel, mPenThick
    tmpDC = CreateCompatibleDC(UserControl.hdc)
    bufDC = CreateCompatibleDC(UserControl.hdc)
    ' 2  
    countPoints = 2
    ReDim Points(countPoints - 1)
    '   
    Points(0).px = 0:   Points(0).py = 0.5
    Points(1).px = 1:   Points(1).py = 0.5
    '   
    mSelected = -1
    
End Sub

' //  
Private Sub UserControl_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
    Dim mSel    As Long
    Dim posX    As Single
    '    
    mSel = GetPointFromPos(x, y)
    
    If mSel >= 0 Then
        
        If Button = vbLeftButton Then
            '   
            mSelected = mSel
            Redraw
            
        ElseIf Button = vbRightButton Then
            '   
            RemovePoint mSel
            Redraw
            
        End If
        
    Else
        
        If Button = vbLeftButton Then
            '   
            mSel = AddPoint(x, y)
        
            If mSel Then
        
                mSelected = mSel
                Redraw
            
            End If
            
        End If
        
    End If
    
End Sub

' //  
Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
    
    If mSelected >= 0 Then
        '  ,   
        MovePoint mSelected, x / UserControl.ScaleWidth, y / UserControl.ScaleHeight
        Redraw
        
    End If
    
End Sub

' //  
Private Sub UserControl_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
    
    If mSelected >= 0 Then
        
        mSelected = -1
        Redraw
        
    End If
    
End Sub

' // 
Private Sub UserControl_Paint()
    
    If mRedrawBack Then
        Redraw
    End If
    
    BitBlt UserControl.hdc, 0, 0, UserControl.ScaleWidth, UserControl.ScaleHeight, _
           bufDC, 0, 0, vbSrcCopy
           
End Sub

' //  
Private Sub UserControl_Resize()
    
    mRedrawBack = True

End Sub

' //  
Private Sub UserControl_Terminate()

    If gdipToken Then
        
        If CBool(hBufferBmp) Or CBool(hBackBmp) Then
            
            RestoreDC bufDC, -1
            DeleteObject hBackBmp
            DeleteObject hBufferBmp
            GdipDeleteGraphics mBufGraph

        End If
        
        DeleteDC bufDC
        DeleteDC tmpDC
        GdipDeletePen mPenThick
        GdipDeletePen mPenThin
        GdiplusShutdown gdipToken
        
    End If
    
End Sub

' //       
Private Function GetPointFromPos(ByVal x As Long, ByVal y As Long) As Long
    Dim iMarker As Long
    Dim dx      As Long
    Dim dy      As Long
    Dim rad     As Long
    
    rad = MarkerSize * MarkerSize \ 4
    
    For iMarker = 0 To countPoints - 1
        
        dx = x - Points(iMarker).px * UserControl.ScaleWidth
        dy = y - Points(iMarker).py * UserControl.ScaleHeight
        
        If dx * dx + dy * dy - rad <= 0 Then

            GetPointFromPos = iMarker
            Exit Function

        End If
        
    Next
    
    GetPointFromPos = -1
    
End Function

' //  
Private Function Interpolation(ByVal X1 As Single, ByVal X2 As Single, ByVal t As Single) As Single
    Dim t2 As Single
    t2 = (1 - Cos(t * 3.14)) / 2
    Interpolation = (X1 * (1 - t2) + X2 * t2)
End Function
