VERSION 5.00
Begin VB.Form frmSettings 
   BackColor       =   &H00000000&
   BorderStyle     =   0  'None
   Caption         =   "Settings"
   ClientHeight    =   3465
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4140
   MaxButton       =   0   'False
   MinButton       =   0   'False
   Picture         =   "frmSettings.frx":0000
   ScaleHeight     =   231
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   276
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Begin VB.ListBox lstDev 
      Appearance      =   0  'Flat
      BackColor       =   &H0024000D&
      Height          =   1860
      IntegralHeight  =   0   'False
      Left            =   165
      Style           =   1  'Checkbox
      TabIndex        =   2
      Top             =   525
      Width           =   3810
   End
   Begin TrickVocoder.ctlTrickCommand btnOK 
      Height          =   375
      Left            =   1485
      TabIndex        =   0
      Top             =   2850
      Width           =   1170
      _ExtentX        =   2064
      _ExtentY        =   661
      Icon            =   "frmSettings.frx":4785
   End
   Begin TrickVocoder.ctlTrickCommand btnClose 
      Height          =   165
      Left            =   3870
      TabIndex        =   1
      ToolTipText     =   "Open carrier"
      Top             =   75
      Width           =   165
      _ExtentX        =   291
      _ExtentY        =   291
      Icon            =   "frmSettings.frx":819B
   End
End
Attribute VB_Name = "frmSettings"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' frmSettings  -   TrickVocoder
'     (The trick), 2014

Option Explicit

Private mResult     As VbMsgBoxResult       '  
Private mDevID      As Long                 '   
Private mFileName   As String               '   

Dim WithEvents lstRender As clsTrickListBox '  OWNERDRAW 
Attribute lstRender.VB_VarHelpID = -1

Dim nmFont  As StdFont                      ' 

' //  
Public Property Get Result() As VbMsgBoxResult
    Result = mResult
End Property

' //  
Public Property Get SelectedDevice() As Long
    SelectedDevice = mDevID
End Property

' //  
Public Property Get FileName() As String
    FileName = mFileName
End Property

' //    
Private Sub btnOK_Click()

    mResult = vbOK
    mDevID = lstDev.ListIndex - 1
    
    Unload Me
    
End Sub

' // 
Private Sub Form_Load()
    '    
    SetWindowLong lstDev.hwnd, GWL_STYLE, GetWindowLong(lstDev.hwnd, GWL_STYLE) And Not WS_BORDER
    SetWindowPos lstDev.hwnd, 0, 0, 0, 0, 0, SWP_NOMOVE Or SWP_NOSIZE Or SWP_NOZORDER Or SWP_FRAMECHANGED
    '  
    Set nmFont = New StdFont
    
    nmFont.Name = "Arial"
    nmFont.Size = 6
    
    Dim dev As Variant
    Dim cap As clsTrickSound
    Dim dID As Long
    '   
    Set cap = frmTrickVocoder.AudioCaptureDevice
    '       
    lstDev.AddItem "Default"
    '    
    For Each dev In cap.CaptureDevices
        lstDev.AddItem dev
    Next
    
    err.Clear
    '    
    On Error Resume Next
    dID = cap.CurrentCaptureDeviceID()
    On Error GoTo 0
    
    If err.Number Then
    
        MsgBox "Error current capture device", vbCritical
        lstDev.AddItem "From file..."
        
    Else
        '    
        If Len(frmTrickVocoder.InputFileName) Then
            
            lstDev.AddItem frmTrickVocoder.InputFileName
            
        Else
            '   
            lstDev.ListIndex = IIf(dID = -1, 0, cap.CurrentCaptureDeviceID + 1)
            lstDev.AddItem "From file..."
            
        End If
        
    End If
    '  
    Set lstRender = New clsTrickListBox
    Set lstRender.ListBox = lstDev
    lstRender.DefaultDraw = False
    lstRender.ItemHeight = 15
    
    Dim hRgn As Long
    '   
    hRgn = CreateRoundRectRgn(0, 0, Me.ScaleWidth, Me.ScaleHeight, 2, 2)
    SetWindowRgn Me.hwnd, hRgn, False
    
    mResult = vbCancel
    
End Sub

' //    
Private Sub Form_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
    Dim pos As Currency
    
    If y <= 26 Then
        '      ,   
        ReleaseCapture
        GetCursorPos pos
        SendMessage Me.hwnd, WM_NCLBUTTONDOWN, HTCAPTION, pos
        
    End If
    
End Sub

' //  
Private Sub btnClose_Click()
    Unload Me
End Sub

' //   
Private Sub lstDev_Click()
    Dim pt  As Size
    Dim rc  As RECT
    '   
    GetCursorPos pt
    ScreenToClient lstDev.hwnd, pt
    SendMessage lstDev.hwnd, LB_GETITEMRECT, lstDev.ListCount - 1, rc
    '    ,     
    If pt.cx >= rc.Left And pt.cx <= rc.Right And _
       pt.cy >= rc.Top And pt.cy <= rc.Bottom Then
        mFileName = GetFile(Me.hwnd)
    End If
    
End Sub

' //   
Private Sub lstRender_Draw(ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal width As Long, _
                           ByVal height As Long, ByVal index As Long, ByVal State As StateEnum)
    Dim fnt As IFont
    Dim rc  As RECT
    
    SaveDC hdc
    
    SetBkMode hdc, TRANSPARENT

    Set fnt = nmFont
        
    SetRect rc, x, y, x + width, y + height
    
    SelectObject hdc, fnt.hFont
    SelectObject hdc, GetStockObject(DC_BRUSH)
    SelectObject hdc, GetStockObject(DC_PEN)
    
    Select Case State
    Case ES_NORMAL

        SetDCPenColor hdc, lstDev.BackColor
        SetDCBrushColor hdc, lstDev.BackColor
        SetTextColor hdc, toVBColor(col_Text)
        
    Case Else
                
        SetDCPenColor hdc, toVBColor(col_FrameColor)
        SetDCBrushColor hdc, toVBColor(col_Curve)
        SetTextColor hdc, toVBColor(col_TextPanel)
            
    End Select
    
    Rectangle hdc, rc.Left, rc.Top, rc.Right, rc.Bottom
    rc.Top = rc.Top + 2: rc.Left = rc.Left + 2
    DrawText hdc, StrPtr(lstDev.List(index)), -1, rc, 0
    
    RestoreDC hdc, -1
    
End Sub
