VERSION 5.00
Begin VB.Form frmTrickVocoder 
   BackColor       =   &H00000000&
   BorderStyle     =   0  'None
   Caption         =   "TrickVocoder"
   ClientHeight    =   3705
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4140
   ForeColor       =   &H00FFFFFF&
   MaxButton       =   0   'False
   MinButton       =   0   'False
   Picture         =   "frmTrickVocoder.frx":0000
   ScaleHeight     =   247
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   276
   StartUpPosition =   3  'Windows Default
   Begin TrickVocoder.ctlTrickCommand btnOpenCarrier 
      Height          =   165
      Left            =   3750
      TabIndex        =   4
      ToolTipText     =   "Open carrier"
      Top             =   2325
      Width           =   165
      _ExtentX        =   291
      _ExtentY        =   291
      Icon            =   "frmTrickVocoder.frx":5926
   End
   Begin TrickVocoder.ctlTrickKnob knbBands 
      Height          =   765
      Left            =   1335
      TabIndex        =   1
      ToolTipText     =   "Number of frequency bands"
      Top             =   2850
      Width           =   585
      _ExtentX        =   1032
      _ExtentY        =   1349
      Min             =   4
      Max             =   128
      Value           =   48
   End
   Begin TrickVocoder.ctlTrickEqualizer equResponse 
      Height          =   1740
      Left            =   165
      TabIndex        =   0
      Top             =   555
      Width           =   3825
      _ExtentX        =   6747
      _ExtentY        =   3069
   End
   Begin TrickVocoder.ctlTrickKnob knbMix 
      Height          =   765
      Left            =   2220
      TabIndex        =   2
      ToolTipText     =   "Dry mix"
      Top             =   2850
      Width           =   585
      _ExtentX        =   1032
      _ExtentY        =   1349
      Value           =   0
   End
   Begin TrickVocoder.ctlTrickKnob knbVolume 
      Height          =   795
      Left            =   3120
      TabIndex        =   3
      ToolTipText     =   "Output volume"
      Top             =   2850
      Width           =   585
      _ExtentX        =   1032
      _ExtentY        =   1402
      Max             =   150
      Value           =   100
   End
   Begin TrickVocoder.ctlTrickCommand btnSettings 
      Height          =   165
      Left            =   3525
      TabIndex        =   5
      ToolTipText     =   "Settings"
      Top             =   2325
      Width           =   165
      _ExtentX        =   291
      _ExtentY        =   291
      Icon            =   "frmTrickVocoder.frx":5D44
   End
   Begin TrickVocoder.ctlTrickKnob knbPitch 
      Height          =   765
      Left            =   450
      TabIndex        =   6
      ToolTipText     =   "Pitch shift"
      Top             =   2850
      Width           =   585
      _ExtentX        =   1032
      _ExtentY        =   1349
      Min             =   -36
      Max             =   36
      Value           =   0
   End
   Begin TrickVocoder.ctlTrickCommand btnClose 
      Height          =   165
      Left            =   3870
      TabIndex        =   7
      ToolTipText     =   "Open carrier"
      Top             =   75
      Width           =   165
      _ExtentX        =   291
      _ExtentY        =   291
      Icon            =   "frmTrickVocoder.frx":6162
   End
End
Attribute VB_Name = "frmTrickVocoder"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' frmTrickVocoder  -   TrickVocoder
'     (The trick), 2014

Option Explicit

Dim WithEvents AudioCapture     As clsTrickSound    '   
Attribute AudioCapture.VB_VarHelpID = -1
Dim WithEvents AudioPlayback    As clsTrickSound    '   
Attribute AudioPlayback.VB_VarHelpID = -1

Private inpBuffer() As Integer                      '   
Private outBuffer() As Integer                      '   
Private rawBuffer() As Integer                      '     Wave-
Private plyBuffer   As clsTrickOverlappedBuffer     '    
Private capBuffer   As clsTrickOverlappedBuffer     '    
Private FFT         As clsTrickFFT                  '     FFT    
Private Modulator   As clsTrickModulator            ' 
Private mFFTSize    As Long                         '  FFT
Private mOverlap    As Long                         '  
Private mRawSize    As Long                         '      
Private mInpFile    As String                       '  ,    
Private tmpCapBuf() As Single                       '   
Private tmpPlyBuf() As Single                       '   
Private wavConv     As clsTrickWavConverter         ' -  
Private inpConv     As clsTrickWavConverter         ' -  

' //   
Public Property Get AudioCaptureDevice() As clsTrickSound
    Set AudioCaptureDevice = AudioCapture
End Property

' //    
Public Property Get InputFileName() As String
    InputFileName = mInpFile
End Property

' //  
Private Sub btnClose_Click()
    Unload Me
End Sub

' //    
Private Sub btnOpenCarrier_Click()
    Dim FileName    As String
    Dim conv        As clsTrickWavConverter
    '   
    FileName = GetFile(Me.hwnd)
    
    If Len(FileName) Then

        Set conv = New clsTrickWavConverter
        '        
        If conv.ReadWaveFile(FileName) Then
            Set wavConv = conv
        End If
        
    End If
    
End Sub

' // 
Private Sub btnSettings_Click()
    Dim frm As frmSettings
    Dim cur As Long
    
    Set frm = New frmSettings
    
    frm.Show vbModal
    '   
    If frm.Result = vbOK Then
        '    
        cur = AudioCapture.CurrentCaptureDeviceID()
        '  , ..           
        memset inpBuffer(0), mFFTSize * 2, 0
        
        If frm.SelectedDevice >= AudioCapture.CaptureDevices.count Then
            '   
            Set inpConv = Nothing
            Set inpConv = New clsTrickWavConverter
            '  
            If Not inpConv.ReadWaveFile(frm.FileName) Then
                '  
                InitCapture cur
                
            Else
            
                mInpFile = frm.FileName
                AudioCapture.StopProcess
                
            End If
            
        Else
            '   
            AudioPlayback.StopProcess
            
            If Not InitCapture(frm.SelectedDevice) Then
                InitCapture cur
            Else
                mInpFile = vbNullString
            End If
            
            On Error Resume Next
            AudioCapture.StartProcess
            AudioPlayback.StartProcess
            On Error GoTo 0
            
            If err.Number Then
                MsgBox ""
            End If
            
        End If
        
    End If
    
End Sub

' //  
Private Sub equResponse_Change()
    Dim data() As Single
    
    ReDim data(mFFTSize \ 2 - 1)
    '   
    equResponse.GetCurve data()
    '  
    Modulator.SetLevels data()
    
End Sub

' //  
Private Sub Form_Load()
    '  FFT
    mFFTSize = 2048
    ' 
    mOverlap = 2
    '  
    If Not InitPlayback() Then Unload Me
    '  
    If Not InitCapture() Then
        Call btnSettings_Click
    Else
        AudioCapture.StartProcess
    End If
    
    Set plyBuffer = New clsTrickOverlappedBuffer
    Set capBuffer = New clsTrickOverlappedBuffer
    '   
    plyBuffer.Init mFFTSize, mFFTSize \ mOverlap
    capBuffer.Init mFFTSize, mFFTSize \ mOverlap
    
    Set FFT = New clsTrickFFT
    '     
    FFT.FFTSize = mFFTSize
    FFT.WindowType = WT_HANN
    
    Set Modulator = New clsTrickModulator
    '  
    ReDim tmpCapBuf(1, mFFTSize - 1)
    ReDim tmpPlyBuf(1, mFFTSize - 1)
    ReDim inpBuffer(mFFTSize - 1)
    ReDim outBuffer(mFFTSize - 1)
    '  
    Call equResponse_Change
    Call knbBands_Change
    Call knbMix_Change
    Call knbVolume_Change
    Call knbPitch_Change
    '  
    AudioPlayback.StartProcess
    
    Dim hRgn    As Long
    '   
    hRgn = CreateRoundRectRgn(0, 0, Me.ScaleWidth, Me.ScaleHeight, 2, 2)
    SetWindowRgn Me.hwnd, hRgn, False
    '  
    SetIcon Me.hwnd
End Sub

' //      
Private Sub AudioCapture_NewData(ByVal DataPtr As Long, ByVal CountBytes As Long)
    '    
    memcpy inpBuffer(0), ByVal DataPtr, CountBytes
End Sub

' //     
Private Sub AudioPlayback_NewData(ByVal DataPtr As Long, ByVal CountBytes As Long)
    '   
    Call Process
    ' 
    memcpy ByVal DataPtr, outBuffer(0), CountBytes
End Sub

' // 
Private Sub Process()
    Dim ovrLap      As Long
    Dim ret         As Long
    Dim idx         As Long
    Dim delta       As Single
    Dim datSize     As Long
    
    If Len(mInpFile) Then
        '   
        inpConv.Convert VarPtr(inpBuffer(0)), mFFTSize * 2, ret
        '   ,   
        If ret < mFFTSize * 2 Then
            inpConv.InputCurrentPosition = 0
            inpConv.Convert VarPtr(inpBuffer(ret \ 2)), mFFTSize * 2 - ret, ret
        End If
        
    End If
    '     
    If wavConv Is Nothing Then
        '        
        outBuffer = inpBuffer
        Exit Sub
        
    End If
    '     
    FFT.Convert16BitToComplex inpBuffer(), tmpCapBuf()
    '     
    capBuffer.WriteInputData tmpCapBuf()
    '   ( )  
    datSize = wavConv.Rate * wavConv.InputDataSize \ 2
    
    If datSize < mRawSize Then
        '   
        wavConv.Convert VarPtr(rawBuffer(0)), mRawSize * 2, ret
        '    ,  
        If ret * 2 <> datSize Then
        
            wavConv.InputCurrentPosition = 0
            wavConv.Convert VarPtr(rawBuffer(ret \ 2)), datSize * 2 - ret, ret
            
        End If
        '      
        ret = datSize
        idx = 0
        
        Do While ret < mRawSize
        
            rawBuffer(ret) = rawBuffer(idx)
            ret = ret + 1
            idx = idx + 1
            
        Loop
        '  
        wavConv.InputCurrentPosition = ((wavConv.InputCurrentPosition + idx) Mod datSize)
        
    Else
        '   
        wavConv.Convert VarPtr(rawBuffer(0)), mRawSize * 2, ret
        '   ,   
        If ret < mRawSize * 2 Then
        
            wavConv.InputCurrentPosition = 0
            wavConv.Convert VarPtr(rawBuffer(ret \ 2)), mRawSize * 2 - ret, ret
        End If
        
    End If
    
    ' /     
    delta = 2 ^ (knbPitch.Value / 12)
    For idx = 0 To mFFTSize - 1
        outBuffer(idx) = rawBuffer(Fix(idx * delta))
    Next
    '       
    FFT.Convert16BitToComplex outBuffer(), tmpPlyBuf()
    '     
    plyBuffer.WriteInputData tmpPlyBuf()

    '   
    For ovrLap = 0 To mOverlap - 1

        '   
        capBuffer.GetInputBuffer tmpCapBuf()
        plyBuffer.GetInputBuffer tmpPlyBuf()
        '   
        FFT.FFT tmpCapBuf(), False
        FFT.FFT tmpPlyBuf(), False
        ' 
        Modulator.Process tmpPlyBuf(), tmpCapBuf()
        ' 
        FFT.MakeMirror tmpPlyBuf()
        '   
        FFT.FFT tmpPlyBuf(), True
        ' 
        FFT.ApplyWindow tmpPlyBuf()
        '   
        plyBuffer.WriteOutputData tmpPlyBuf()

    Next
    
    '  
    plyBuffer.GetOutputBuffer tmpPlyBuf()
    ' 
    FFT.ConvertComplexTo16Bit tmpPlyBuf(), outBuffer()
    
End Sub

' //   
Private Function InitCapture(Optional DeviceID As Long = -1) As Boolean
    On Error GoTo ERROR_LABEL
    Set AudioCapture = Nothing
    
    Set AudioCapture = New clsTrickSound
    AudioCapture.InitCapture 1, SampleRate, 16, mFFTSize, DeviceID
    
    InitCapture = True
    
    Exit Function
ERROR_LABEL:
    
    MsgBox "Error initialize capture", vbCritical
    
End Function

' //   
Private Function InitPlayback(Optional DeviceID As Long = -1) As Boolean
    On Error GoTo ERROR_LABEL
    Set AudioPlayback = Nothing
    
    Set AudioPlayback = New clsTrickSound
    AudioPlayback.InitPlayback 1, SampleRate, 16, mFFTSize, DeviceID
    
    InitPlayback = True
    
    Exit Function
ERROR_LABEL:
    
    MsgBox "Error initialize playback", vbCritical
    
End Function

' //    
Private Sub Form_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
    Dim pos As Currency
    
    If y <= 26 Then
        '      ,   
        ReleaseCapture
        GetCursorPos pos
        SendMessage Me.hwnd, WM_NCLBUTTONDOWN, HTCAPTION, pos
        
    End If
    
End Sub

' //   
Private Sub knbBands_Change()
    
    Modulator.Bands = knbBands.Value
    knbBands.Caption = knbBands.Value
    
End Sub

' //  
Private Sub knbMix_Change()
    Dim lg As Single
    '  
    lg = ((10 ^ (knbMix.Value / 50)) - 1) / 99
    Modulator.DryWet = lg
    knbMix.Caption = Format(lg, "#0.00%")
        
End Sub

' //   
Private Sub knbPitch_Change()
    
    mRawSize = -Int(-mFFTSize * (2 ^ (knbPitch.Value / 12)))
    ReDim rawBuffer(mRawSize - 1)
    
    knbPitch.Caption = Format(knbPitch.Value, "0 sem;-0 sem;non\e")
    
End Sub

' //  
Private Sub knbVolume_Change()
    Dim lg As Single
    '  
    lg = ((10 ^ (knbVolume.Value / 50)) - 1) / 99
    Modulator.Volume = lg
    knbVolume.Caption = Format(lg, "#0.00%")
            
End Sub
